#!/usr/bin/perl -w
#
# Version 0.1 by Red Pingu <redpingu@caramail.com>
# Version 0.2 by Vetinari <iranitev@gmx.net> (Vetinari@IRCNet)
# 
# Usage: 
#      /MUSIC 
#        or
#      /MUSIC SHOW
#           sends: "/me is playing XMMS_PLAYLIST_SONG_NAME"
#      /MUSIC ON
#           turns auto sending of song names ON
#      /MUSIC OFF
#           turns auto sending of song names OFF
#      /MUSIC TO (CHANNEL|NICK)
#           sends the automaticly generated actions to NICK (or CHANNEL),
#           has effect only when auto sending is ON. 
#           If Your IRC server does not restrict actions to one target, you
#           may use for example '/music to #channel_A,#channel_B,Nick_C'
#      /MUSIC TO
#           whithout CHANNEL or NICK the action is send to the generator 
#           of the activating PRIVMSG; if this is a PRIVMSG to a channel,
#           the action is sent to that channel.
#      /MUSIC HELP
#           gives a short usage help
#
#
IRC::register("Xmms Script", "0.2", "", "");
IRC::print "Loading Xmms script (version 0.2)\n";
IRC::add_message_handler("PRIVMSG", "privmsg_handler");
IRC::add_command_handler("music", "music_handler");
use vars qw($xmms_last_change $xmms_file 
            $xmms_auto_on     %xmms_command
            $xmms_sendto );
$xmms_last_change = time;
$xmms_auto_on     = 0;
$xmms_file        = "$ENV{'HOME'}/.xmms/current_file";
$xmms_sendto      = '';
%xmms_command     = (
      'help' => sub { IRC::print("xmms script: Usage: /MUSIC "
                                 . "[ON|OFF|TO [NICK|CHANNEL]|SHOW|HELP]\n");
                    },
      'on'   => sub { $xmms_auto_on = 1;
                      IRC::print("xmms script: MUSIC: ON\n");  
                      $xmms_command{'to'}->($xmms_sendto);
                    },
      'off'  => sub { $xmms_auto_on = 0; 
                      IRC::print("xmms script: MUSIC: OFF\n");
                    },  
      'show' => sub { &put_current_file('/me') },
      'to'   => sub { @_ ? 
                         ($xmms_sendto = shift) : 
                         ($xmms_sendto = ''); 
                      IRC::print("xmms script: SENDING " 
                                 . (($xmms_sendto =~ /^$/) ? 
                                     'anywhere' : "to $xmms_sendto") 
                                 . "\n");
                    },
               );

sub privmsg_handler {
    return undef
        unless $xmms_auto_on;
    $time_now = (stat($xmms_file))[9];
    if ($time_now > $xmms_last_change) {
        $xmms_last_change = $time_now;
        my $action = '/me';
        if ($xmms_sendto !~ /^$/) {
           $action = "/ctcp $xmms_sendto action";
        }
        &put_current_file($action);
    }
    return undef;
}

sub put_current_file {
    my $action = shift;
    open(HANDLE, $xmms_file);
    # open(HANDLE, $xmms_file) 
    #     or do { 
    #         IRC::print("xmms script: Could not open $xmms_file: $!\n");
    #         return;
    #     };
    IRC::command("$action is playing ".<HANDLE>);
    close(HANDLE);
}

sub music_handler {
    my $arg = shift;
    $arg =~ s/^\s*//;
    $arg =~ s/\s*$//;
    my @command = split /\s+/, $arg;
    my $cmd = lc shift @command;
    if (defined $cmd && $cmd !~ /^$/) {
        if (exists $xmms_command{$cmd}) {
            $xmms_command{$cmd}->(@command);
        } else {
            $xmms_command{'help'}->();
        }
    } else {
        $xmms_command{'show'}->();
    }
    return 1;
}

